SystemOrganization addCategory: #ConfigurationOfESUGDemo!

Object subclass: #ConfigurationOfESUGDemo
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfESUGDemo'!

!ConfigurationOfESUGDemo class methodsFor: 'development support' stamp: 'JPSA 8/27/2012 09:41'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfESUGDemo class methodsFor: 'private' stamp: 'JPSA 8/27/2012 09:41'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfESUGDemo class methodsFor: 'private' stamp: 'JPSA 8/27/2012 09:41'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfESUGDemo class methodsFor: 'private' stamp: 'JPSA 8/27/2012 09:41'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfESUGDemo class methodsFor: 'metacello tool support' stamp: 'JPSA 8/27/2012 09:41'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfESUGDemo class methodsFor: 'loading' stamp: 'JPSA 8/27/2012 09:41'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfESUGDemo class methodsFor: 'loading' stamp: 'JPSA 8/27/2012 09:41'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfESUGDemo class methodsFor: 'loading' stamp: 'JPSA 8/27/2012 09:41'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfESUGDemo class methodsFor: 'accessing' stamp: 'JPSA 8/27/2012 09:41'!
project

	^self new project! !

!ConfigurationOfESUGDemo class methodsFor: 'development support' stamp: 'JPSA 8/27/2012 09:41'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfESUGDemo methodsFor: 'baselines' stamp: 'JPSA 8/27/2012 09:41'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/VExample'.
		spec package: 'ESUGDemo'.
		spec group: 'default' with: #('ESUGDemo' ). ].
! !

!ConfigurationOfESUGDemo methodsFor: 'symbolic versions' stamp: 'JPSA 8/27/2012 11:18'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.2'.
! !

!ConfigurationOfESUGDemo methodsFor: 'accessing' stamp: 'JPSA 8/27/2012 09:41'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfESUGDemo methodsFor: 'versions' stamp: 'JPSA 8/27/2012 09:42'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : add bar method'.
		spec author: 'JPSA'.
		spec timestamp: '8/27/2012 09:42'.
		spec package: 'ESUGDemo' with: 'ESUGDemo-JPSA.2'. ].
! !

!ConfigurationOfESUGDemo methodsFor: 'versions' stamp: 'JPSA 8/27/2012 11:17'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : add bar method
1.1 : adding something'.
		spec author: 'JPSA'.
		spec timestamp: '8/27/2012 11:17'.
		spec package: 'ESUGDemo' with: 'ESUGDemo-JPSA.12'. ].
! !

!ConfigurationOfESUGDemo methodsFor: 'versions' stamp: 'JPSA 8/27/2012 11:18'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.1 : adding something'.
		spec author: 'JPSA'.
		spec timestamp: '8/27/2012 11:18'.
		spec package: 'ESUGDemo' with: 'ESUGDemo-JPSA.12'. ].
! !
